package libtime;

$VERSION = "0.05";
$TIMESTAMP = "1998/04/02";

# 1998/04/02	0.05	եեޥåȤ%Eɲ
#			AM/PMդäԶ罤
# 1998/03/26	0.04	&timestr()%N%nѹ%tѻ
# 1998/03/25	0.03	&timestr()ɲ
# 1998/03/12	0.02	&gmtimestr()ɲ
# 1998/03/06	0.01	hina.pl 1.956򸵤˿


$TZ = "JST-9";
@MSTR =
    ("Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", 
    "Oct", "Nov", "Dec");
@MSTRL =
    ("January", "February", "March", "April", "May", "June",
     "July", "August", "September", "October", "November", "December");
@WSTR =
    ("Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat");
@WSTRL =
    ("Sunday", "Monday", "Tuesday", "Wednesday",
     "Thursday", "Friday", "Saturday");

@JMSTR =
    ("Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", 
    "Oct", "Nov", "Dec");
@JWSTR =
    ("", "", "", "", "", "", "");


sub main'timelocal
{
    local($sec, $min, $hour, $mday, $mon, $year) = @_;
    $year += 1900;

    local($time) = time();
    local($tz) = &main'timegm(localtime($time)); #'

    $tz -= &main'timegm(gmtime($time));

    $time = &xtimegm($sec, $min, $hour, $mday, $mon, $year)
	- &xtimegm(0, 0, 0, 1, 0, 1970) - $tz;

    return($time);
}

sub main'timegm
{
    local($sec, $min, $hour, $mday, $mon, $year) = @_;
    $year += 1900;

    local($time) = &xtimegm($sec, $min, $hour, $mday, $mon, $year)
	- &xtimegm(0, 0, 0, 1, 0, 1970);

    return($time);
}

sub xtimegm
{
    local($sec, $min, $hour, $mday, $mon, $year) = @_;
    local(@mdays) =
	(0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334);

    local($uru) = ((($year % 4) == 0) &&
		   ((($year % 100) != 0) || (($year % 400) == 0)));

    $mday--;

    $mday += $mdays[$mon];
    $mday++ if (($mon > 1) && ($uru));

    $mday += $year * 365;
    $year--;
    $mday += int($year / 4) - int($year / 100) + int($year / 400);

    $hour += $mday * 24;
    $min += $hour * 60;
    $sec += $min * 60;

    return($sec);
}

sub main'gmtimestr
{
    return(&main'timestr(shift, "%C", "GMT"));
}

sub main'timestr
{
    local($time) = shift;
    local($format) = "%C";
    $format = shift if ($#_ >= 0);
    local($zl) = "";
    $zl = shift if ($#_ >= 0);

    local($sec, $min, $hour, $mday, $mon, $year,
	  $wday, $yday, $isdst);

    if ($zl eq "")
    {
	($sec, $min, $hour, $mday, $mon, $year,
	 $wday, $yday, $isdst) = localtime($time);
	$zl = $TZ;
    }
    else
    {
	if ($zl eq "JST")
	{
	    $zl = "JST-9";
	}
	elsif ($zl eq "EST")
	{
	    $zl = "EST-5";
	}

	if ($zl =~ /([\+\-])(\d+)/o)
	{
	    local($sign) = "$1";
	    local($shour) = "$2";
	    local($smin) = 0;
	    local($shift);

	    if ($shour =~ /(\d{2})(\d{2})/o)
	    {
		$shour = "$1";
		$smin = "$2";
	    }
	    $shour =~ s/^0+//og;
	    $smin =~ s/^0+//og;

	    $shift = ($shour * 60 + $smin) * 60;
	    if ($sign eq "+")
	    {
		$time -= $shift;
	    }
	    elsif ($sign eq "-")
	    {
		$time += $shift;
	    }

	}

	($sec, $min, $hour, $mday, $mon, $year,
	 $wday, $yday, $isdst) = gmtime($time);
    }

    $zl =~ s/[\+\-]\d*//og;
	
    local($a) = $WSTR[$wday];
    local($al) = $WSTRL[$wday];
    local($b) = $MSTR[$mon];
    local($bl) = $MSTRL[$mon];
    local($d) = sprintf("%02d", $mday);
    local($e) = sprintf("%2d", $mday);
    local($el) = sprintf("%d", $mday);
    local($hl) = sprintf("%02d", $hour);
    local($il) = sprintf("%02d", (($hour + 11) % 12) + 1);
    local($jl) = $JWSTR[$wday];
    local($m) = sprintf("%02d", $mon + 1);
    local($ml) = sprintf("%02d", $min);
    local($n) = sprintf("%d", $mon + 1);
    local($p) = ($hour > 11) ? "PM" : "AM";
    local($sl) = sprintf("%02d", $sec);
    local($w) = sprintf("%d", $wday);
    local($y) = sprintf("%02d", $year % 100);
    local($yl) = sprintf("%04d", ($year - 70) % 100 + 1970);

    $format =~ s/\%C/\%a\, \%d \%b \%Y \%T \%Z/og;
    $format =~ s:\%D:\%m\/\%d\/\%y:og;
    $format =~ s/\%T/\%R\:\%S/og;
    $format =~ s/\%R/\%H\:\%M/og;
    $format =~ s/\%h/\%b/og;
    $format =~ s/\%r/\%I\:\%M\:\%S \%p/og;

    $format =~ s/\%a/$a/g;
    $format =~ s/\%A/$al/g;
    $format =~ s/\%b/$b/g;
    $format =~ s/\%B/$bl/g;
    $format =~ s/\%d/$d/g;
    $format =~ s/\%e/$e/g;
    $format =~ s/\%E/$el/g;
    $format =~ s/\%H/$hl/g;
    $format =~ s/\%I/$il/g;
    $format =~ s/\%J/$jl/g;
    $format =~ s/\%m/$m/g;
    $format =~ s/\%M/$ml/g;
    $format =~ s/\%n/$n/g;
    $format =~ s/\%p/$p/g;
    $format =~ s/\%S/$sl/g;
    $format =~ s/\%w/$w/g;
    $format =~ s/\%y/$y/g;
    $format =~ s/\%Y/$yl/g;
    $format =~ s/\%Z/$zl/g;

    return($format);
}

1;
